package com.kdm.provider.data;

import java.io.Serializable;

public enum Field implements Serializable { 	
	SEIS_SET_ID("id", true), 
	NAME("name", true), 
	DIMENSION("dimension", true), 
	FOLD("fold", true), 
	FSP("fsp", false),
	LSP("lsp", false),
	FINLINE("fnline", false),
	LINLINE("lnline", false),
	FXLINE("fxline", false),
	LXLINE("lxline", false),
	VINTAGE("vintage", true), 
	LINE_ID("lineId", true),
	PROJECT_ID("projectId", true),
	PROJECT_NAME("projectName", true),
	SURVEY_ID("surveyId", true),
	SURVEY_NAME("surveyName", true),
	OWNERSHIP_CLASS("ownershipClass", true),
	ORIGINAL_OWNER("originalOwner", true),
	CURRENT_OWNER("currentOwner", true),
	SHOT_FOR("shotFor", true),
	SHOT_BY("shotBy", true),
	ENERGY_TYPE("energyType", true),
	ALIAS_NAME("aliasName", true),
	GEOMETRY("geometry", false),
	AREA("area", true),
	AFE("afe", true),
	EBCDIC_HEADER("ebcdicHeader", true),
	CATEGORY("inventory.category", true),
	SUBCATEGORY("inventory.subcategory", true),
	INVENTORY_ID("inventory.id", true),
	INVENTORY_TYPE("inventory.type", true),
	ORIGINAL_FILE_NAME("inventory.originalFileName", true),
	OUTPUT_FILE_NAME("inventory.outputFileName", true),
	DIGITAL_FORMAT("inventory.digitalFormat", true),
	LOCATION("inventory.location", true),
	FILE_SIZE("inventory.fileSize", false),
	INVENTORY_TITLE("inventory.title", true),
	INVENTORY_DESCRIPTION("inventory.description", true),
	INVENTORY_PROCESS_DATE("inventory.processDate", false),
	OWNER_BA("ownerBa", false),
	__RANGES__("__ranges__", false) // TODO refactor
	;
	
	private static final long serialVersionUID = 1L;
	private String name;
	private boolean highlighted;


	Field(String name, boolean highlighted) {
		this.name = name;
		this.highlighted = highlighted;
	}
	
	public String getName() {
		return this.name;
	}
	
	public boolean highlighted() { return highlighted; }
	
	public static Field byName(String name) {
		if (name != null) {
			for (Field f : Field.values()) {
				if (name.equalsIgnoreCase(f.name)) {
					return f;
				}
			}
		}
		throw new IllegalArgumentException("No field with name "+name+" found");
	}
}